package diego.aop;

/**
 * Some components call Components.createInstance() directly which makes testing tricky sometimes.
 *
 * This interface allows me to replace the default ApplicationDependencyContainerService with a stub or a mock. Further,
 * this approach allows me to better encapsulate the dependency injection logic so that I easily make changes.
 *
 * @author Kevin Sheppard
 * Date: July 08, 2023
 */
public interface DependencyContainerService {
    <T> T getBean(Class<T> beanClass);
}
