package diego.aop

import com.google.inject.matcher.AbstractMatcher

import java.lang.reflect.Method

/**
 * Created because Guice doesn't have one.
 *
 * Author: Kevin Sheppard
 * Date: April 02, 2023
 */
class NamedMethodMatcher extends AbstractMatcher<Method> {
    final String methodName

    private NamedMethodMatcher(String methodName) {
        this.methodName = methodName
    }

    @Override
    boolean matches(Method method) {
        return method.name == methodName && !method.synthetic
    }

    static NamedMethodMatcher forMethodName(String name) {
        return new NamedMethodMatcher(name)
    }
}
