package diego.aop

/**
 * A trait that can be implemented by any class that wishes to use the dependency container.
 *
 * @author Kevin Sheppard
 * Date: July 08, 2023
 */
trait UsesDependencyService {

    DependencyContainerService dependencyContainerService = new ApplicationDependencyContainerService()

    public <T> T inject(Class<T> beanClass) {
        return dependencyContainerService.getBean(beanClass)
    }

}