package diego.db

import com.google.inject.matcher.AbstractMatcher

import java.lang.reflect.Method

/**
 * A matcher that encapsulates the logic for determining which methods in the HttpServerResponse should trigger
 * Session termination.
 *
 * @author Kevin Sheppard
 * Date: Aug 17, 2022
 */
class HttpServerResponseMethodMatcher extends AbstractMatcher<Method> {

  @Override
  boolean matches(Method method) {
    return method.returnType == Void.TYPE // Any public methods with a void type signify the end of a request->response cycle.
  }
}
