package diego.db

import com.google.inject.Inject
import org.hibernate.Session

/**
 * A Trait that houses common functionality for all classes that work with a SessionManager.
 *
 * @author Kevin Sheppard
 * Date: July 07, 2023
 */
trait SessionStore {
    SessionManager sessionManager

    Session getSession() {
        return sessionManager.session
    }

    @Inject
    void setSessionManager(SessionManager sessionManager) {
        this.sessionManager = sessionManager
    }
}
