package diego.logging

import ch.qos.logback.classic.spi.ILoggingEvent
import ch.qos.logback.core.AppenderBase
import com.typesafe.config.ConfigFactory
import diego.db.Database
import diego.db.DatabaseImpl

import diego.db.SessionFactoryProvider

/**
 * An appender for storing logs in the application database. Not ready for prime time, but it's promising...
 */
class DatabaseLogger extends AppenderBase<ILoggingEvent> {

    private static final Database db = createDatabase()
    final static String sql = "insert into LOGS(level, logger, message) values(?, ?, ?)"

    @Override
    protected void append(ILoggingEvent eventObject) {
        db.withCloseable {
            it.createQuery(sql,
                    eventObject.level.toString(),
                    eventObject.loggerName,
                    eventObject.formattedMessage).executeUpdate()
        }
    }

    private static Database createDatabase() {
        final var sf = new SessionFactoryProvider(ConfigFactory.load().getConfig("db")).get()
        return new DatabaseImpl(sf)
    }
}
