package diego.templates

import com.fasterxml.jackson.databind.ObjectMapper
import com.google.inject.Inject
import freemarker.template.TemplateMethodModelEx
import freemarker.template.TemplateModelException

/**
 *
 *
 * @author Kevin Sheppard
 * Date: Jul 05, 2023
 */
class JsonMethod implements TemplateMethodModelEx {
    private final ObjectMapper objectMapper

    @Inject
    JsonMethod(ObjectMapper objectMapper) {
        this.objectMapper = objectMapper
    }

    @Override
    Object exec(List arguments) throws TemplateModelException {
        if(arguments.empty) return "{}"
        return objectMapper.writeValueAsString(arguments[0])
    }
}
