package diego.templates;

import io.vertx.core.http.HttpServerRequest;

import java.util.Map;

/**
 * A lightweight version of the HttpServerRequest meant to be used in templates.
 *
 * @author Kevin Sheppard
 * Date: Jul 06, 2023
 */
public interface RequestModel {

    static RequestModel create(HttpServerRequest source) {
        return new RequestModelImplementation(source);
    }

    String getPath();

    Map<String, Object> getParams();
}
