package diego.templates;

import java.util.Map;

/**
 * @author Kevin Sheppard
 * Date: Jul 05, 2023
 */
public interface TemplateEngine {
  /**
   *
    * @param templateName The name of the template e.g. index.ftl
   * @return A rendered template string.
   */
  String render(String templateName);

 /**
  *
  * @param templateName templateName The name of the template e.g. index.ftl
  * @param data Data to pass to the template.
  * @return A rendered template string.
  */
  String render(String templateName, Map<String, Object> data);
}
