package diego.tooling

import java.util.regex.Pattern

/**
 * Prints to the standard output and executes code once it detects that a build has completed.
 *
 * @author Kevin Sheppard
 * Date: Feb 28, 2023
 */
class ReactiveOutputStream extends OutputStream {
  private StringBuilder lines = new StringBuilder()
  private final Pattern goodLines = Pattern.compile("(modified|build|successful|failed)", Pattern.CASE_INSENSITIVE)
  private final Runnable buildListener

  ReactiveOutputStream(Runnable buildListener) {
    this.buildListener = buildListener
  }

  @Override
  void write(int character) throws IOException {
    lines.append((char) character)
    if(character == 10 || character == 13) {
      String line = lines.toString()
      if(line =~ goodLines) println(line)
      if(line.containsIgnoreCase("build successful")) buildListener.run()
      lines = new StringBuilder()
    }
  }
}
