package diego.utils.httpclient

import org.apache.http.HttpEntity
import org.apache.http.entity.ContentType

/**
 * Class for storing form parameters.
 *
 * @author Kevin Sheppard
 * Date: Jan 06, 2022
 */
abstract class FormData {

  abstract FormData addParameter(String name, String... values)

  protected abstract ContentType getEncType()

  protected abstract HttpEntity getEntity()

  static UrlEncodedForm createBasicForm(Map<String, String> params = [:]) {
    return new UrlEncodedForm().withParameters(params)
  }

  static MultiPartForm createMultipartForm(Map<String, Object> params = [:]) {
    return new MultiPartForm().withParameters(params)
  }

}
