package diego.utils.httpclient

import org.apache.http.client.methods.HttpDelete
import org.apache.http.client.methods.HttpGet
import org.apache.http.client.methods.HttpPatch
import org.apache.http.client.methods.HttpPost
import org.apache.http.client.methods.HttpPut

/**
 * Standardized entries for HTTP Methods.
 *
 * @author Kevin Sheppard
 * Date: Jan 06, 2022
 */
enum HttpMethod {
  DELETE(HttpDelete.METHOD_NAME),
  GET(HttpGet.METHOD_NAME),
  PATCH(HttpPatch.METHOD_NAME),
  POST(HttpPost.METHOD_NAME),
  PUT(HttpPut.METHOD_NAME)

  public final String methodName

  HttpMethod(String methodName) {
    this.methodName = methodName
  }
}