package diego.validation

import diego.utils.FastRuntimeException

/**
 * An exception thrown when form validation fails.
 *
 * @author Kevin Sheppard
 * Date: May 12, 2023
 */
class FormValidationException extends FastRuntimeException {
  private final LinkedHashMap<String, List<String>> constraintViolations

  FormValidationException(LinkedHashMap<String, List<String>> constraintViolations) {
    super('Validation failed')
    this.constraintViolations = constraintViolations
  }

  LinkedHashMap<String, List<String>> getConstraintViolations() {
    return constraintViolations
  }
}
