package diego.validation

import com.fasterxml.jackson.databind.ObjectMapper
import com.google.inject.Inject
import diego.web.HttpServerRequest

/**
 * Takes a request with a JSON body and returns a domain object.
 *
 * @author Kevin Sheppard
 * Date: May 12, 2023
 */
class JsonRequestParser implements RequestParser {

    private ObjectMapper objectMapper

    @Inject
    JsonRequestParser(ObjectMapper objectMapper) {
        this.objectMapper = objectMapper
    }

    @Override
    <T> T parseRequest(HttpServerRequest request, Class<T> klass) {
        return objectMapper.readValue(request.body.toString(), klass)
    }
}
