package diego.validation.constraints

import jakarta.validation.Constraint
import jakarta.validation.Payload

import java.lang.annotation.Documented
import java.lang.annotation.Retention
import java.lang.annotation.Target
import static java.lang.annotation.ElementType.*
import static java.lang.annotation.RetentionPolicy.RUNTIME

/**
 * @author Kevin Sheppard
 * Date: May 19, 2023
 */
@Target([ FIELD, METHOD, PARAMETER, ANNOTATION_TYPE ])
@Retention(RUNTIME)
@Constraint(validatedBy = RequiredValidator )
@Documented
@interface Required {
  String message() default "{messages.required}";

  Class<?>[] groups() default [];

  Class<? extends Payload>[] payload() default [];
}