package diego.validation.constraints

import jakarta.validation.ConstraintValidator
import jakarta.validation.ConstraintValidatorContext

/**
 * @author Kevin Sheppard
 * Date: May 19, 2023
 */
class RequiredValidator implements ConstraintValidator<Required, Object> {

  @Override
  boolean isValid(Object value, ConstraintValidatorContext context) {
    if(value == null) return false
    if(value instanceof Collection) return !(value as Collection).empty
    if(value instanceof String) return !(value as String).empty
    return true
  }
}
