package diego.web

import com.google.inject.Inject
import io.vertx.core.Handler
import io.vertx.core.http.HttpServerRequest
import io.vertx.ext.web.Router

/**
 * This class was created so that we can write encapsulating logic around
 * the handling of each request that comes to the server.
 *
 * For example, we can intercept the handle() method on this class to clean up any
 * lingering database connections or transactions once the request has been served to the user.
 *
 * Author: Kevin Sheppard
 * Date: April 01, 2023
 */
class HttpRequestHandler implements Handler<HttpServerRequest> {
    final @Delegate Router delegate

    @Inject
    HttpRequestHandler(Router delegate) {
        this.delegate = delegate
    }
}
