package diego.web.impl

import diego.web.Cookie
import io.vertx.core.http.Cookie as VCookie

/**
 * HTTP cookie implementation.
 *
 * @author Kevin Sheppard
 * Date: Jan 10, 2022
 */
class CookieImpl implements Cookie {

  private VCookie vertxCookie

  CookieImpl(VCookie vertxCookie) {
    this.vertxCookie = vertxCookie
  }

  CookieImpl setMaxAge(long maxAge) {
    vertxCookie.setMaxAge(maxAge)
    return this
  }

  Cookie setPath(String path) {
    vertxCookie.setPath(path)
    return this
  }

  Cookie setDomain(String domain) {
    vertxCookie.domain
    return this
  }

  String getName() {
    return vertxCookie.name
  }

  String getValue() {
    return vertxCookie.value
  }

  String getPath() {
    return vertxCookie.path
  }

  String getDomain() {
    return vertxCookie.domain
  }

  long getMaxAge() {
    return vertxCookie.maxAge
  }
}
